package com.amqp.shanxi.service.impl;

import cn.hutool.json.JSONUtil;
import com.amqp.shanxi.dao.AlarmInfoDao;
import com.amqp.shanxi.model.*;
import com.amqp.shanxi.service.AlarmDataService;
import com.amqp.shanxi.util.AESUtil;
import com.amqp.shanxi.util.StaticParamUtils;
import org.springframework.amqp.core.AmqpTemplate;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;

@Service
public class AlarmDataServiceImpl implements AlarmDataService {

    @Autowired
    private AmqpTemplate amqpTemplate;

    @Autowired
    private AlarmInfoDao alarmInfoDao;

    @Override
    public String gantanAlarm() {
        try {
            StaticDataInfoModel gantanAlarmInfo = new StaticDataInfoModel();
            List<GantanAlarmInfoModel> gantanAlarmData = alarmInfoDao.findGantanAlarmData();
            for (GantanAlarmInfoModel gantanAlarmInfoModel : gantanAlarmData) {
                // 报警
                gantanAlarmInfoModel.setSensorno(StaticParamUtils.GANTANNO + (gantanAlarmInfoModel.getRecordid() >= 10 ? String.valueOf(gantanAlarmInfoModel.getRecordid()) : "0" + gantanAlarmInfoModel.getRecordid()));
                if (gantanAlarmInfoModel.getWarningdata().contains(".")) {
                    gantanAlarmInfoModel.setWarningdata(gantanAlarmInfoModel.getWarningdata().substring(0, gantanAlarmInfoModel.getWarningdata().indexOf(".")));
                } else {
                    gantanAlarmInfoModel.setWarningdata(gantanAlarmInfoModel.getWarningdata());
                }
            }
            System.out.println("gt报警======================" + JSONUtil.toJsonStr(gantanAlarmData));
            if (gantanAlarmData.size() > 0) {
                gantanAlarmInfo.setTailingNo(StaticParamUtils.WKKNO);
                gantanAlarmInfo.setDepartmentId("911402247485664344");
                gantanAlarmInfo.setProvinceId(StaticParamUtils.PROVINCENO);
                gantanAlarmInfo.setType(StaticParamUtils.GANTANALARM);
                gantanAlarmInfo.setSendTime(new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(new Date()));
                gantanAlarmInfo.setDatas(AESUtil.encrypt(JSONUtil.toJsonStr(gantanAlarmData), "i2MvNzkedPgITpz2UcZS3A==", "ReQb3Swiz8frJ3+8l9RGvg=="));
            }
            return JSONUtil.toJsonStr(gantanAlarmInfo);
        }catch (Exception e) {
            e.printStackTrace();
            return null;
        }
    }

    @Override
    public String kushuiweiAlarm() {
        try {
            StaticDataInfoModel kswAlarmInfo = new StaticDataInfoModel();
            List<KushuiweiAlarmInfoModel> kushuiweiAlarmData = alarmInfoDao.findKushuiweiAlarmData();
            for (KushuiweiAlarmInfoModel kswAlarmInfoModel : kushuiweiAlarmData) {
                // 报警
                kswAlarmInfoModel.setSensorno(StaticParamUtils.KUSHUIWEINO + (kswAlarmInfoModel.getRecordid() >= 10 ? String.valueOf(kswAlarmInfoModel.getRecordid()) : "0" + kswAlarmInfoModel.getRecordid()));
                if (kswAlarmInfoModel.getWarningdata().contains(".")) {
                    kswAlarmInfoModel.setWarningdata(kswAlarmInfoModel.getWarningdata().substring(0, kswAlarmInfoModel.getWarningdata().indexOf(".")));
                } else {
                    kswAlarmInfoModel.setWarningdata(kswAlarmInfoModel.getWarningdata());
                }
            }
            System.out.println("ksw报警======================" + JSONUtil.toJsonStr(kushuiweiAlarmData));
            if (kushuiweiAlarmData.size() > 0) {
                kswAlarmInfo.setTailingNo(StaticParamUtils.WKKNO);
                kswAlarmInfo.setDepartmentId("911402247485664344");
                kswAlarmInfo.setProvinceId(StaticParamUtils.PROVINCENO);
                kswAlarmInfo.setType(StaticParamUtils.KUSHUIWEIALARM);
                kswAlarmInfo.setSendTime(new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(new Date()));
                kswAlarmInfo.setDatas(AESUtil.encrypt(JSONUtil.toJsonStr(kushuiweiAlarmData), "i2MvNzkedPgITpz2UcZS3A==", "ReQb3Swiz8frJ3+8l9RGvg=="));
            }
            return JSONUtil.toJsonStr(kswAlarmInfo);
        }catch (Exception e) {
            e.printStackTrace();
            return null;
        }
    }

    @Override
    public String biaomianweiyiAlarm() {
        try {
            StaticDataInfoModel bmwyAlarmInfo = new StaticDataInfoModel();
            List<BiaomianweiyiAlarmInfoModel> biaomianweiyiAlarmData = alarmInfoDao.findBiaomianweiyiAlarmData();
            for (BiaomianweiyiAlarmInfoModel bmwyAlarmInfoModel : biaomianweiyiAlarmData) {
                // 报警
                bmwyAlarmInfoModel.setSensorno(StaticParamUtils.BIAOMIANWEIYINO + (bmwyAlarmInfoModel.getRecordid() >= 10 ? String.valueOf(bmwyAlarmInfoModel.getRecordid()) : "0" + bmwyAlarmInfoModel.getRecordid()));
                if (bmwyAlarmInfoModel.getWarningdata().contains(".")) {
                    bmwyAlarmInfoModel.setWarningdata(bmwyAlarmInfoModel.getWarningdata().substring(0, bmwyAlarmInfoModel.getWarningdata().indexOf(".")));
                } else {
                    bmwyAlarmInfoModel.setWarningdata(bmwyAlarmInfoModel.getWarningdata());
                }
            }
            System.out.println("bmwy报警======================" + JSONUtil.toJsonStr(biaomianweiyiAlarmData));
            if (biaomianweiyiAlarmData.size() > 0) {
                bmwyAlarmInfo.setTailingNo(StaticParamUtils.WKKNO);
                bmwyAlarmInfo.setDepartmentId("911402247485664344");
                bmwyAlarmInfo.setProvinceId(StaticParamUtils.PROVINCENO);
                bmwyAlarmInfo.setType(StaticParamUtils.BIAOMIANWEIYIALARM);
                bmwyAlarmInfo.setSendTime(new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(new Date()));
                bmwyAlarmInfo.setDatas(AESUtil.encrypt(JSONUtil.toJsonStr(biaomianweiyiAlarmData), "i2MvNzkedPgITpz2UcZS3A==", "ReQb3Swiz8frJ3+8l9RGvg=="));
            }
            return JSONUtil.toJsonStr(bmwyAlarmInfo);
        }catch (Exception e) {
            e.printStackTrace();
            return null;
        }
    }

    @Override
    public String jinrunxianAlarm() {
        try {
            StaticDataInfoModel jrxAlarmInfo = new StaticDataInfoModel();
            List<JinrunxianAlarmInfoModel> jinrunxianAlarmData = alarmInfoDao.findJinrunxianAlarmData();
            for (JinrunxianAlarmInfoModel jrxAlarmInfoModel : jinrunxianAlarmData) {
                // 报警
                jrxAlarmInfoModel.setSensorno(StaticParamUtils.JINRUNXIANNO + (jrxAlarmInfoModel.getRecordid() >= 10 ? String.valueOf(jrxAlarmInfoModel.getRecordid()) : "0" + jrxAlarmInfoModel.getRecordid()));
                if (jrxAlarmInfoModel.getWarningdata().contains(".")) {
                    jrxAlarmInfoModel.setWarningdata(jrxAlarmInfoModel.getWarningdata().substring(0, jrxAlarmInfoModel.getWarningdata().indexOf(".")));
                } else {
                    jrxAlarmInfoModel.setWarningdata(jrxAlarmInfoModel.getWarningdata());
                }
            }
            System.out.println("jrx报警======================" + JSONUtil.toJsonStr(jinrunxianAlarmData));
            if (jinrunxianAlarmData.size() > 0) {
                jrxAlarmInfo.setTailingNo(StaticParamUtils.WKKNO);
                jrxAlarmInfo.setDepartmentId("911402247485664344");
                jrxAlarmInfo.setProvinceId(StaticParamUtils.PROVINCENO);
                jrxAlarmInfo.setType(StaticParamUtils.JINRUNXIANALARM);
                jrxAlarmInfo.setSendTime(new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(new Date()));
                jrxAlarmInfo.setDatas(AESUtil.encrypt(JSONUtil.toJsonStr(jinrunxianAlarmData), "i2MvNzkedPgITpz2UcZS3A==", "ReQb3Swiz8frJ3+8l9RGvg=="));
            }
            return JSONUtil.toJsonStr(jrxAlarmInfo);
        }catch (Exception e) {
            e.printStackTrace();
            return null;
        }
    }

    @Override
    public String jiangyuliangAlarm() {
        try {
            StaticDataInfoModel jylAlarmInfo = new StaticDataInfoModel();
            List<JiangyuliangAlarmInfoModel> jylAlarmData = alarmInfoDao.findJiangyuliangAlarmData();
            for (JiangyuliangAlarmInfoModel jylAlarmInfoModel : jylAlarmData) {
                // 报警
                jylAlarmInfoModel.setSensorno(StaticParamUtils.JIANGYULIANGNO + (jylAlarmInfoModel.getRecordid() >= 10 ? String.valueOf(jylAlarmInfoModel.getRecordid()) : "0" + jylAlarmInfoModel.getRecordid()));
                if (jylAlarmInfoModel.getWarningdata().contains(".")) {
                    jylAlarmInfoModel.setWarningdata(jylAlarmInfoModel.getWarningdata().substring(0, jylAlarmInfoModel.getWarningdata().indexOf(".")));
                } else {
                    jylAlarmInfoModel.setWarningdata(jylAlarmInfoModel.getWarningdata());
                }
            }
            System.out.println("jyl报警======================" + JSONUtil.toJsonStr(jylAlarmData));
            if (jylAlarmData.size() > 0) {
                jylAlarmInfo.setTailingNo(StaticParamUtils.WKKNO);
                jylAlarmInfo.setDepartmentId("911402247485664344");
                jylAlarmInfo.setProvinceId(StaticParamUtils.PROVINCENO);
                jylAlarmInfo.setType(StaticParamUtils.JIANGYULIANGALARM);
                jylAlarmInfo.setSendTime(new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(new Date()));
                jylAlarmInfo.setDatas(AESUtil.encrypt(JSONUtil.toJsonStr(jylAlarmData), "i2MvNzkedPgITpz2UcZS3A==", "ReQb3Swiz8frJ3+8l9RGvg=="));
            }
            return JSONUtil.toJsonStr(jylAlarmInfo);
        }catch (Exception e) {
            e.printStackTrace();
            return null;
        }
    }

    @Override
    public String deviceAlarm() {
        try {
            StaticDataInfoModel deviceAlarmInfo = new StaticDataInfoModel();
            List<DeviceAlarmInfoModel> deviceAlarmData = alarmInfoDao.findDeviceAlarmData();
            for (int i = 0; i < deviceAlarmData.size(); i++) {
                if (deviceAlarmData.get(i).getItemno().contains("干滩")) {
                    deviceAlarmData.get(i).setItemno("01");
                } else if (deviceAlarmData.get(i).getItemno().contains("库水位")) {
                    deviceAlarmData.get(i).setItemno("02");
                } else if (deviceAlarmData.get(i).getItemno().contains("坝体表面位移")) {
                    deviceAlarmData.get(i).setItemno("03");
                } else if (deviceAlarmData.get(i).getItemno().contains("雨量计")) {
                    deviceAlarmData.get(i).setItemno("06");
                } else if (deviceAlarmData.get(i).getItemno().contains("浸润线")) {
                    deviceAlarmData.get(i).setItemno("05");
                } else if (deviceAlarmData.get(i).getItemno().contains("坝体内部")) {
                    deviceAlarmData.get(i).setItemno("04");
                }
                deviceAlarmData.get(i).setWarningdata(new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(new Date()));
            }
            System.out.println("device报警============" + JSONUtil.toJsonStr(deviceAlarmData));
            if (deviceAlarmData.size() > 0) {
                deviceAlarmInfo.setTailingNo(StaticParamUtils.WKKNO);
                deviceAlarmInfo.setDepartmentId("911402247485664344");
                deviceAlarmInfo.setProvinceId(StaticParamUtils.PROVINCENO);
                deviceAlarmInfo.setType(StaticParamUtils.DEVICEALARM);
                deviceAlarmInfo.setSendTime(new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(new Date()));
                deviceAlarmInfo.setDatas(AESUtil.encrypt(JSONUtil.toJsonStr(deviceAlarmData), "i2MvNzkedPgITpz2UcZS3A==", "ReQb3Swiz8frJ3+8l9RGvg=="));
            }
            return JSONUtil.toJsonStr(deviceAlarmInfo);
        }catch (Exception e) {
            e.printStackTrace();
            return null;
        }
    }

    @Override
    public String wkkAlarm() {
        try {
            StaticDataInfoModel wkkAlarmInfo = new StaticDataInfoModel();
            List<WkkAlarmTimeInfoModel> wkkAlarmData = alarmInfoDao.findWkkAlarmData();
            for (WkkAlarmTimeInfoModel wkkAlarmTimeInfoModel : wkkAlarmData) {
                wkkAlarmTimeInfoModel.setWarningdata(new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(new Date()));
            }
            System.out.println("wkk报警=====================" + JSONUtil.toJsonStr(wkkAlarmData));
            if (wkkAlarmData.size() > 0) {
                wkkAlarmInfo.setTailingNo(StaticParamUtils.WKKNO);
                wkkAlarmInfo.setDepartmentId("911402247485664344");
                wkkAlarmInfo.setProvinceId(StaticParamUtils.PROVINCENO);
                wkkAlarmInfo.setType(StaticParamUtils.WKKALARM);
                wkkAlarmInfo.setSendTime(new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(new Date()));
                wkkAlarmInfo.setDatas(AESUtil.encrypt(JSONUtil.toJsonStr(wkkAlarmData), "i2MvNzkedPgITpz2UcZS3A==", "ReQb3Swiz8frJ3+8l9RGvg=="));
            }
            return JSONUtil.toJsonStr(wkkAlarmInfo);
        }catch (Exception e) {
            e.printStackTrace();
            return null;
        }
    }

    /**
     * 内部沉降
     * @return
     */
    @Override
    public String neibuchenjiangAlarm() {
        try {
            StaticDataInfoModel nbwyAlarmInfo = new StaticDataInfoModel();
            List<NeibuweiyiAlarmInfoModel> neibuchenjiangAlarmData = alarmInfoDao.findNeibuchenjiangAlarmData();
            for (NeibuweiyiAlarmInfoModel nbwyAlarmInfoModel : neibuchenjiangAlarmData) {
                // 报警
                nbwyAlarmInfoModel.setSensorno(StaticParamUtils.NEIBUWEIYINO + (nbwyAlarmInfoModel.getRecordid() >= 10 ? String.valueOf(nbwyAlarmInfoModel.getRecordid()) : "0" + nbwyAlarmInfoModel.getRecordid()));
                if (nbwyAlarmInfoModel.getWarningdata().contains(".")) {
                    nbwyAlarmInfoModel.setWarningdata(nbwyAlarmInfoModel.getWarningdata().substring(0, nbwyAlarmInfoModel.getWarningdata().indexOf(".")));
                } else {
                    nbwyAlarmInfoModel.setWarningdata(nbwyAlarmInfoModel.getWarningdata());
                }
            }
            System.out.println("内部沉降报警======================" + JSONUtil.toJsonStr(neibuchenjiangAlarmData));
            if (neibuchenjiangAlarmData.size() > 0) {
                nbwyAlarmInfo.setTailingNo(StaticParamUtils.WKKNO);
                nbwyAlarmInfo.setDepartmentId("911402247485664344");
                nbwyAlarmInfo.setProvinceId(StaticParamUtils.PROVINCENO);
                nbwyAlarmInfo.setType(StaticParamUtils.NEIBUWEIYIALARM);
                nbwyAlarmInfo.setSendTime(new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(new Date()));
                nbwyAlarmInfo.setDatas(AESUtil.encrypt(JSONUtil.toJsonStr(neibuchenjiangAlarmData), "i2MvNzkedPgITpz2UcZS3A==", "ReQb3Swiz8frJ3+8l9RGvg=="));
            }
            return JSONUtil.toJsonStr(nbwyAlarmInfo);
        }catch (Exception e) {
            e.printStackTrace();
            return null;
        }
    }

    /**
     * 内部水平
     * @return
     */
    @Override
    public String neibushuipingAlarm() {
        try {
            StaticDataInfoModel nbwyAlarmInfo = new StaticDataInfoModel();
            List<NeibuweiyiAlarmInfoModel> neibuchenjiangAlarmData = alarmInfoDao.findNeibuchenjiangAlarmData();
            for (NeibuweiyiAlarmInfoModel nbwyAlarmInfoModel : neibuchenjiangAlarmData) {
                // 报警
                nbwyAlarmInfoModel.setSensorno(StaticParamUtils.JIANGYULIANGNO + (nbwyAlarmInfoModel.getRecordid() >= 10 ? String.valueOf(nbwyAlarmInfoModel.getRecordid()) : "0" + nbwyAlarmInfoModel.getRecordid()));
                if (nbwyAlarmInfoModel.getWarningdata().contains(".")) {
                    nbwyAlarmInfoModel.setWarningdata(nbwyAlarmInfoModel.getWarningdata().substring(0, nbwyAlarmInfoModel.getWarningdata().indexOf(".")));
                } else {
                    nbwyAlarmInfoModel.setWarningdata(nbwyAlarmInfoModel.getWarningdata());
                }
            }
            System.out.println("内部水平报警======================" + JSONUtil.toJsonStr(neibuchenjiangAlarmData));
            if (neibuchenjiangAlarmData.size() > 0) {
                nbwyAlarmInfo.setTailingNo(StaticParamUtils.WKKNO);
                nbwyAlarmInfo.setDepartmentId("911402247485664344");
                nbwyAlarmInfo.setProvinceId(StaticParamUtils.PROVINCENO);
                nbwyAlarmInfo.setType(StaticParamUtils.NEIBUWEIYIALARM);
                nbwyAlarmInfo.setSendTime(new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(new Date()));
                nbwyAlarmInfo.setDatas(AESUtil.encrypt(JSONUtil.toJsonStr(neibuchenjiangAlarmData), "i2MvNzkedPgITpz2UcZS3A==", "ReQb3Swiz8frJ3+8l9RGvg=="));
            }
            return JSONUtil.toJsonStr(nbwyAlarmInfo);
        }catch (Exception e) {
            e.printStackTrace();
            return null;
        }
    }
}
